/*   ants.c --- Ants Colony
 *   
 *   Copyright (C) 2000 Valvassori Mose <djedi@altern.org>
 *   
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *   
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *   
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA **/

#define ANTS_C

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "ants.h"
#include <math.h>
#include <stdlib.h>
#include <time.h>

Form *sw,*pix;

XImage *im;
void redraw_pixmap (Form *i);



 /******************** 
  *  Callbacks	     * 
  ********************/
void
quitcb(Form *i)
{
  stop_thread();
  DtK_end(0);
}


void
startcb(Form *i)
{
  sw->redraw =nop;
  init_thread();
}

void
stopcb(Form *i)
{
  stop_thread();
}

void
optioncb(Form *i)
{
  view_options_window();
}




void
redraw_pixmap(Form *i)
{
  /*     default_redraw(i); */
  flush_pixmap(pix,true);
}








/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  Init xlib
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
void
init_x11(int argc,char **argv)
{
  Form *princ,*tool,*b;

  XInitThreads();
  init(argc,argv);
  princ=open_window(0,0,MW+em(14),MH+em(2),"Ants Colony"
		    ,default_redraw);

  sw=subwindow(princ,em(1),em(1),MW,MH,redraw_pixmap);
  XSelectInput(display,sw->window, 
	       ExposureMask |ButtonPressMask| Button1MotionMask |LeaveWindowMask);
  sw->motion = drawing_motion;

   /*  pix =pixmapxpm(sw,0,0,"./splashp.xpm"); */
    pix=pixmap(sw,0,0,MW,MH);
  if (pix == NULL)
    {
      printf("Error  \n");
      exit (2);
    }

  tool=box(princ,MW+em(2),em(1),em(11),MH,normal);

  button(tool,em(1),em(1),em(9),em(3),"Start",startcb);
  button(tool,em(1),em(5),em(9),em(3),"Stop",stopcb);
  b=button(tool,em(1),em(9),em(9),em(3),"Step",nop);
  disable(b);

  button(tool,em(1),em(13),em(9),em(3),"Options",optioncb);

  b=button(tool,em(1),MH-em(8),em(9),em(3),"About",nop);
  disable(b);
  button(tool,em(1),MH-em(4),em(9),em(3),"Exit",quitcb);
  view_window (princ);
  im=image(pix,0,0,MW,MH);

   /* Option Window */
  init_options_window();


}







/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  The Main function. 

int main

int argc

char **argv
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
int
main(int argc,char **argv)
{

  srand(time(NULL));
  /*  srand(0); */
  init_x11(argc,argv);
  wind(wind_angle,wind_strength);
  loop();

  return (0);
}
