/*   drawing.c --- Ants Colony
 *   
 *   Copyright (C) 2000 Valvassori Mose <djedi@altern.org>
 *   
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *   
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *   
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA **/


#define DRAWING_C
#include <stdio.h>
#include <dtk/dtk.h>
#include "ants.h"



/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  This function is called when you move the mouse and press the button 
  on the pixmap window

  Form *i the window where the event come in.
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
void
drawing_motion(Form *form)
{
  int x = event.xmotion.x;
  int y = event.xmotion.y;

  if ((x >= 0) && (x <= MW) && (y >= 0) && (y <= MH))		 /* Check if the mouse is in the window */
    {
      undraw(x,y);
    }
}





/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  draw a pixel on the phremon area

  int x

  int y
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
void
draw(int x,int y)
{
    int i,j;
    int t;

      for (j=-4; j<4; j++)
	for (i=-4; i<4; i++)
	  {
	     t=(int)acces1(x+i,y+j);
	     t+=50;
	     acces1(x+i,y+j)= t>255?255:t;
	  }
}


void
draws(int x,int y,int s)
{
    int i,j;
    int t;

      for (j=-4; j<4; j++)
	for (i=-4; i<4; i++)
	  {
	     t=(int)acces1(x+i,y+j);
	     t+=(s*50/DEFAULT_REST);
	     acces1(x+i,y+j)= t>255?255:t;
	  }
}


void
undraw(int x,int y)
{
    int i,j;
    int t;
#define c 10

      for (j=-c; j<c; j++)
	for (i=-c; i<c; i++)
	  {
	     t=(int)acces1(x+i,y+j);
	     t-=80;
	     acces1(x+i,y+j)= t<=0?0:t;
	  }
}









/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  Draw a food site on the screen

  PIXEL *im the image 

  FOOD f the site
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
void
draw_food(PIXEL *im,FOOD f)
{
  int i;
#define pixel(a,b) (im+(MW*(f.y+b))+(f.x+a))
  unsigned char lsb;
#ifdef HAVE_LIBJPEG
  JSAMPLE *jpg;
#endif
  if (f.rest>0)
    {
      lsb = (int)(f.rest  >> 7);
      lsb = lsb << 3;
      
      for (i=-4; i<5; i++)
	{
	  pixel(i,-4)->lsb = lsb;
	  pixel(i,5)->lsb = lsb;
	  pixel(-4,i)->lsb = lsb;
	  pixel(5,i)->lsb = lsb;

#ifdef HAVE_LIBJPEG
      *(image_buffer+3*((MW*(f.y-4))+(f.x+i)))= f.rest>>4;
      *(image_buffer+3*((MW*(f.y+5))+(f.x+i)))= f.rest>>4;
      *(image_buffer+3*((MW*(f.y+i))+(f.x-4)))= f.rest>>4;
      *(image_buffer+3*((MW*(f.y+i))+(f.x+5)))= f.rest>>4;
#endif
	}
    }
}

